events/urls.py
from django.urls import path, include
from . import views
from django.contrib import admin

app_name = 'events'

urlpatterns= [
    path('', views.events, name='events'),
    path('<uuid:uuid>', views.event, name='event'),
    path('form/', views.events_form, name='events_form'),
    path('pin_event/', views.pin_event, name='pin_event'), 
    path('unpin_event/', views.unpin_event, name='unpin_event'),
    path('register_event/', views.register_event, name='register_event'),
    path('registerations/', views.registrations, name='registrations'),
]

festhub/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from . import views

# Customise admin headings
admin.site.site_header = "FestHub Admin"
admin.site.site_title = "FestHub Admin Portal"
admin.site.index_title = "Welcome to FestHub Admin"


urlpatterns = [
    path('admin/', admin.site.urls),

    path('', views.homepage, name='home'),
    path('dashboard/', views.dashboard, name='dashboard'),
    path('registered_events/',views.registered_events, name='registered_events'),
    
    # Event specific paths
    path('events/', include('events.urls')),
    path('committees/', include('committees.urls')),

    # Account specific paths
    path('accounts/', include('accounts.urls')),

    path('about/', views.about, name='about'),
    path('profile/<str:username>/', views.profile, name='profile'),
    path('committee/',views.committee,name='committee')
]

# Serve media files during development
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

events/models.py
import datetime
from django.db import models
from django.core.validators import MinValueValidator
from django.core.exceptions import ValidationError
from django.core.validators import FileExtensionValidator
from django.contrib.auth.models import User
from committees.models import Committee
from django.db.models.signals import pre_delete
from django.dispatch import receiver
import uuid

def validate_image_size(image):
    file_size = image.file.size
    limit_kb = 512
    if file_size > limit_kb * 1024:
        raise ValidationError("Max size of file is %s KB" % limit_kb)


class Faq(models.Model):
    uuid = models.UUIDField(primary_key=True, default=uuid.uuid4, editable=False)
    question = models.CharField(max_length=200)
    answer = models.TextField()
    event = models.ForeignKey('Event', on_delete=models.CASCADE, related_name='faqs', null=True)

class Rule(models.Model):
    uuid = models.UUIDField(primary_key=True, default=uuid.uuid4, editable=False)
    rule = models.TextField()
    event = models.ForeignKey('Event', on_delete=models.CASCADE, related_name='rules', null=True)

class Event(models.Model):
    NATURE_CHOICES = [
        ('TECH', 'Technical'),
        ('NON_TECH', 'Non-Technical'),
        ('CULTURAL', 'Cultural'),
        ('OTHER', 'Other'),
    ]

    LEVEL_CHOICES = [
        ('COLLEGE', 'College Level'),
        ('DEPARTMENT', 'Department Level'),
        ('INTER_COLLEGE', 'Inter-College Level'),
        ('OTHER', 'Other'),
    ]

    EVENT_TYPE_CHOICES = [
        ('INTERNAL', 'Internal'),
        ('EXTERNAL', 'External'),
    ]

    uuid = models.UUIDField(primary_key=True, default=uuid.uuid4, editable=False)
    name = models.CharField(max_length=200)
    date_time = models.DateTimeField(default=datetime.datetime(2050, 1, 1, 12, 0, 0))
    venue = models.CharField(max_length=200, default="SPIT")
    prize_pool = models.DecimalField(max_digits=10, decimal_places=2, default=0.00)
    committees = models.ManyToManyField(Committee, verbose_name="Committee")

    banner = models.ImageField(
        
        upload_to='events/',
        default='defaults/event_banner.webp',
        validators=[FileExtensionValidator(allowed_extensions=['jpg', 'jpeg', 'png', 'gif', 'webp'])]  
    )
    
    nature = models.CharField(max_length=20, choices=NATURE_CHOICES, default='OTHER', null=True)
    level = models.CharField(max_length=20, choices=LEVEL_CHOICES, default='OTHER', null=True)
    event_type = models.CharField(max_length=20, choices=EVENT_TYPE_CHOICES, default='OTHER', null=True)
    contact_info = models.CharField(max_length=100, blank=True, null=True)
    email = models.EmailField(blank=True, null=True)
    website = models.URLField(blank=True,default='#')
    description = models.TextField(blank=True, null=True)
    created_at = models.DateTimeField(auto_now_add=True)
    published = models.BooleanField(default=True)

    def __str__(self):
        return self.name
    
    def date_only_field(self):
        return self.datetime_field.date()
    
class UserEvent(models.Model):
    uuid = models.UUIDField(primary_key=True, default=uuid.uuid4, editable=False)
    user = models.ForeignKey(User, on_delete=models.CASCADE, related_name='interests')
    event = models.ForeignKey(Event, on_delete=models.CASCADE, related_name='interests')
    pinned = models.BooleanField(default=False)
    registered = models.BooleanField(default=False)

    class Meta:
        unique_together = ['user', 'event']

    def __str__(self):
        return f"{self.user.username}-{self.event.name}"  

frontend/models.py
from django.db import models

# Create your models here.

events/forms.py
from django import forms
from.models import Event
from django.forms.widgets import SelectDateWidget
import uuid


class CustomTextInput(forms.TextInput):
    def __init__(self, *args, **kwargs):
        kwargs.setdefault('attrs', {})
        kwargs['attrs'].update({'class': 'formbold-form-input'})
        super().__init__(*args, **kwargs)

class CustomTextarea(forms.Textarea):
    def __init__(self, *args, **kwargs):
        kwargs.setdefault('attrs', {})
        kwargs['attrs'].update({'class': 'formbold-form-input'})
        super().__init__(*args, **kwargs)

class CustomSelect(forms.Select):
    def __init__(self, *args, **kwargs):
        kwargs.setdefault('attrs', {})
        kwargs['attrs'].update({'class': 'formbold-form-input'})
        super().__init__(*args, **kwargs)

class EventsForm(forms.ModelForm):
    banner = forms.ImageField(label='banner', required=False)

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        for field_name, field in self.fields.items():
            if isinstance(field.widget, (forms.TextInput, forms.Select, forms.Textarea)):
                field.widget.attrs.update({'class': 'formbold-form-input'})

    class Meta:
        model = Event
        fields = '__all__'
        
        widgets = {
            "date_time": forms.DateTimeInput(attrs={'placeholder': 'Enter date and time here...', 'type': 'datetime-local'}), 
            "name": forms.TextInput(attrs={'placeholder': 'Enter name here...'}),  
              
            "venue": forms.Textarea(attrs={'placeholder': 'Enter address here...', 'rows': 3}),  
            "prize_pool": forms.NumberInput(attrs={'placeholder': 'Enter prize pool here...', 'step': '100'}),  

            

            "nature": forms.Select(attrs={'placeholder': 'Select nature...'}),  
            "level": forms.Select(attrs={'placeholder': 'Select level...'}),  
            "event_type": forms.Select(attrs={'placeholder': 'Select event type...'}),  
            "contact_info": forms.TextInput(attrs={'placeholder': 'Enter contact info here...'}),  
            "email": forms.EmailInput(attrs={'placeholder': 'Enter email here...'}),  
            "website": forms.URLInput(attrs={'placeholder': 'Enter website here...'}),  
            "description": forms.Textarea(attrs={'placeholder': 'Enter description here...', 'rows': 8}),  
        }

        
        def save(self, commit=True):
            event = super().save(commit=False)
            event.uuid = uuid.uuid4()
            if commit:
                event.save()
            return event

events/views.py
from django.contrib import messages
from django.shortcuts import get_object_or_404, render, redirect
from django.contrib.auth.decorators import login_required

from festhub.utils import check_profile_completed
from .forms import EventsForm
from .models import Event, UserEvent
from django.urls import reverse
from profiles.models import Profile

@login_required(login_url='accounts:login')
def events(request):
    if not check_profile_completed(request):
        # If profile is not complete, redirect to complete profile page
        return redirect('accounts:completeProfile', user_id=request.user.id)
    events = Event.objects.filter(published=True)
    pinned_events = UserEvent.objects.filter(user=request.user, pinned=True).values_list('event__uuid', flat=True)
    registered_events = UserEvent.objects.filter(user=request.user, registered=True).values_list('event__uuid', flat=True)
    user_committees = request.user.profile.committees.all()
    context={
        'events': events,
        'pinned_events': pinned_events,
        'registered_events': registered_events,
        'user_committees': user_committees,
    }
    return render(request, 'events/events.html',context)

@login_required(login_url='accounts:login')
def event(request, uuid):
    """Display details of a specific event."""
    if not check_profile_completed(request):
        # If profile is not complete, redirect to complete profile page
        return redirect('accounts:completeProfile', user_id=request.user.id)
    event_instance = get_object_or_404(Event, uuid=uuid)
    faqs = event_instance.faqs.all() 
    rules = event_instance.rules.all()
    reg=False
    user_interest = UserEvent.objects.get_or_create(user=request.user, event=event_instance)
    if user_interest[0].registered:
        reg=True
    
    context = {
        'event': event_instance,
        'faqs': faqs,  
        'rules': rules,
        'reg':reg,
    }
    return render(request, 'events/event.html', context)

@login_required(login_url='accounts:login')
def events_form(request):
    """Handle event creation form."""
    if not check_profile_completed(request):
        # If profile is not complete, redirect to complete profile page
        return redirect('accounts:completeProfile', user_id=request.user.id)
    
    if request.method == 'POST':
        form = EventsForm(request.POST, request.FILES)
        if form.is_valid():
            event = form.save()
            # Redirect to the event detail page
            return redirect('events:event', uuid=event.uuid)
    else:
        form = EventsForm()
    user_committees = request.user.profile.committees.all()
    context = {
        'form': form,
        'user_committees': user_committees,
    }
    return render(request, 'events/events_form.html',context)


@login_required(login_url='accounts:login')
def pin_event(request):
    if not check_profile_completed(request):
        # If profile is not complete, redirect to complete profile page
        return redirect('accounts:completeProfile', user_id=request.user.id)
    if request.method == 'POST':
        event_uuid = request.POST.get('event_uuid')
        event = get_object_or_404(Event, uuid=event_uuid)
        user_interest, created = UserEvent.objects.get_or_create(user=request.user, event=event)
        if not user_interest.pinned:
            user_interest.pinned = True
            user_interest.save()
            messages.success(request, 'Event pinned successfully!')
        else:
            messages.info(request, 'Event is already pinned!')
    return redirect('events:events')

@login_required(login_url='accounts:login')
def unpin_event(request):
    if not check_profile_completed(request):
        # If profile is not complete, redirect to complete profile page
        return redirect('accounts:completeProfile', user_id=request.user.id)
    if request.method == 'POST':
        event_uuid = request.POST.get('event_uuid')
        event = get_object_or_404(Event, uuid=event_uuid)
        interest = UserEvent.objects.filter(user=request.user, event=event, pinned=True).first()
        if interest:
            interest.pinned = False
            interest.save()
            messages.success(request, 'Event unpinned successfully!')
        else:
            messages.info(request, 'Event is not pinned!')
    return redirect('events:events')

@login_required(login_url='accounts:login')
def register_event(request):
    if not check_profile_completed(request):
        # If profile is not complete, redirect to complete profile page
        return redirect('accounts:completeProfile', user_id=request.user.id)

    if request.method == 'POST':
        event_uuid = request.POST.get('event_uuid')
        event = get_object_or_404(Event, uuid=event_uuid)
        user_interest, created = UserEvent.objects.get_or_create(user=request.user, event=event)
        if not user_interest.registered:
            user_interest.registered = True
            user_interest.save()
            messages.success(request, 'Event registered successfully!')
        else:
            messages.info(request, 'Event is already registered!')
    return redirect('events:events')


            
def registrations(request):
    if request.method == 'POST':
        event_uuid = request.POST.get('event_uuid')
        event = get_object_or_404(Event, uuid=event_uuid)
        registrations = UserEvent.objects.filter(event=event, registered=True)

        context = {
            'event': event,
            'registrations': registrations,
        }
        return render(request, 'events/registrations.html', context)

    return redirect('events:events')

frontend/views.py
from django.shortcuts import render

# Create your views here.

frontend/templates/events/event.html
{% extends "base/base.html" %}
{% block style%}
.image-container {
    position: relative;
    height: 55vh;
    text-align: left;
    color: white;
  }

  .image {
    width: 100%;
    height: 100%;
    object-fit: auto;
  }

  .image-content {
    position: absolute;
    bottom: 0;
    left: 0;
    padding: 20px;
    background-color: rgba(0, 0, 0, 0.5);
    backdrop-filter: blur(5px);
    border-radius: 10px;
  }

  .image-content h1,
  .image-content h2,
  .image-content h3 {
    margin: 5px 0;
  }

  .backdrop_blur{
    backdrop-filter: blur(30px);
  }

  .contain {
    color: white;
    padding: 2%;
    {% comment %} height: 50vh; {% endcomment %}
    background-image: linear-gradient(to right, rgba(0, 0, 0, 0.8), rgba(0, 0, 0, 0.5)), url({{event.banner.url}});
    background-size: cover;
    text-align: center;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
  }

  .contain h3 {
    margin-bottom: 20px;
  }

{% endblock style%}
{% block main %}
<div class="image-container">
    <img class="image" src="{{event.banner.url}}" alt="image" />
    <div class="image-content">
      <h1>{{event.name}}</h1>
      <h2>{{event.date_time}}</h2>
      <h3>{{event.venue}}</h3>
    </div>
  </div>

  <div class="contain">
    <div>
      <h5>This Event is organised by: {{ event.committees.all|join:" x " }} <br>{{event.nature}} {{event.event_type}} {{event.level}}</br></h5>
      <hr>
      <h3>{{event.date_time}}</h3>
      <hr>
      <h3>Prize-pool : {{event.prize_pool}}</h3>
      <hr>
    </div>
    <div class="btn-group">
      <button class="btn btn-primary" type="button" data-bs-toggle="offcanvas" data-bs-target="#offcanvasScrolling" aria-controls="offcanvasScrolling">FAQS</button>
      <button class="btn btn-primary" type="button" data-bs-toggle="offcanvas" data-bs-target="#offcanvasScrolling1" aria-controls="offcanvasScrolling">Rules</button>
      {% if reg %}
        <a class="btn btn-primary disabled" href="#" role="button">Registered already</a>
      {% else %}
      <form action="{% url 'events:register_event' %}" method="POST">
        {% csrf_token %}
        <input type="hidden" name="event_uuid" value="{{ event.uuid }}">
        <button type="submit" class="btn btn-primary" role="button">Register</button>
    </form>
      {% endif %}

    </div>

    <div class="offcanvas offcanvas-start" data-bs-scroll="true" data-bs-backdrop="false" tabindex="-1" id="offcanvasScrolling" aria-labelledby="offcanvasScrollingLabel">
      <div class="offcanvas-header">
        <h5 class="offcanvas-title" id="offcanvasScrollingLabel">FAQS</h5>
        <button type="button" class="btn-close" data-bs-dismiss="offcanvas" aria-label="Close"></button>
      </div>
      <div class="offcanvas-body">
        <div class="accordion" id="accordionExample">
          {% for faq in faqs %}
          <div class="accordion-item">
            <h2 class="accordion-header">
              <button class="accordion-button" type="button" data-bs-toggle="collapse" data-bs-target="#collapse{{ forloop.counter }}" aria-expanded="true" aria-controls="collapse{{ forloop.counter }}">
                {{ faq.question }}
              </button>
            </h2>
            <div id="collapse{{ forloop.counter }}" class="accordion-collapse collapse" data-bs-parent="#accordionExample">
              <div class="accordion-body">
                {{ faq.answer }}
              </div>
            </div>
          </div>
          {% endfor %}
          
        </div>
      </div>
    </div>

    <div class="offcanvas offcanvas-start" data-bs-scroll="true" data-bs-backdrop="false" tabindex="-1" id="offcanvasScrolling1" aria-labelledby="offcanvasScrollingLabel">
      <div class="offcanvas-header d-flex justify-content-center bg-primary text-light">
        <h5 class="offcanvas-title" id="offcanvasScrollingLabel">Rules</h5>
        <button type="button" class="btn-close btn-close-white" data-bs-dismiss="offcanvas" aria-label="Close"></button>
      </div>
      <div class="offcanvas-body">
        <ul class="list-group">
          {% for rule in rules %}
          <li class="list-group-item">{{ forloop.counter }}. {{ rule.rule }}</li>
          {% endfor %}
        </ul>
      </div>
    </div>
    <div class="row g-4 py-5 row-cols-1 row-cols-lg-3 justify-content-center image my-5 backdrop_blur">
      <div class="col d-flex align-items-start justify-content-center backdrop_blur">
        <div class="icon-square text-body-emphasis bg-body-secondary d-inline-flex align-items-center justify-content-center fs-4 flex-shrink-0 me-3">
          <svg class="bi" width="1em" height="1em"><use xlink:href="#toggles2"></use></svg>
        </div>
        <div class="justify-content-center">
          <h3 class="fs-2 text-body-emphasis">Description</h3>
        
          {{event.description}}
          
        </div>
      </div>
     
      <div class="col d-flex align-items-start justify-content-center backdrop_blur">
        <div class="icon-square text-body-emphasis bg-body-secondary d-inline-flex align-items-center justify-content-center fs-4 flex-shrink-0 me-3">
          <svg class="bi" width="1em" height="1em"><use xlink:href="#tools"></use></svg>
        </div>
        <div>
          <h3 class="fs-2 text-body-emphasis">Want to contact us?</h3>
          <a href="{{event.website}}">
            Website
          </a>
          <br>
          <br>
          Call:{{event.contact_info}}
          </a>
          <br>
          <br>
          <a href="mailto: {{committees.email}}">
            E-mail
          </a>
        </div>
      </div>
    </div>   
</div>
{% endblock main %}



<div class="btn-group">
  <button class="btn btn-primary" type="button" data-bs-toggle="offcanvas" data-bs-target="#offcanvasScrolling" aria-controls="offcanvasScrolling">FAQS</button>
  <button class="btn btn-primary" type="button" data-bs-toggle="offcanvas" data-bs-target="#offcanvasScrolling1" aria-controls="offcanvasScrolling">Rules</button>
  {% if reg %}
    <a class="btn btn-primary disabled" href="#" role="button">Registered already</a>
  {% else %}
  <form action="{% url 'events:register_event' %}" method="POST">
    {% csrf_token %}
    <input type="hidden" name="event_uuid" value="{{ event.uuid }}">
    <button type="submit" class="btn btn-primary">Register</button>
</form>
  {% endif %}

</div>

frontend/templates/events/events.html
{% extends "base/base.html" %}
{% load custom_filters %}
{% block main %}

{% if user_committees %}
<div class="container mt-5 mb-5 text-center">
    <div class="mt-3 mb-3">
        <a href="{% url 'events:events_form' %}" class="btn btn-primary btn-lg">Add Event</a>
    </div>
</div>
{% endif %}

{% if messages %}
    <div class="container mt-3">
        {% for message in messages %}
            <div class="alert alert-{{ message.tags }} alert-dismissible fade show" role="alert">
                {{ message }}
                <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
            </div>
        {% endfor %}
    </div>
{% endif %}

<div class="album py-5 bg-body-tertiary">
    <div class="container">
        <div class="row row-cols-1 row-cols-sm-2 row-cols-md-3 g-3">
            {% for e in events %}
    <div class="col">
        <div class="card shadow-sm">
            <img src="{{ e.banner.url }}" class="bd-placeholder-img card-img-top" width="100%" height="225" role="img" aria-label="Placeholder: Thumbnail" preserveAspectRatio="xMidYMid slice" focusable="false">
            <div class="card-body">
                <p class="card-text">{{ e.name }}</p>
                <div class="d-flex justify-content-between align-items-center">
                    <div class="btn-group">
                        <a href="{% url 'events:event' uuid=e.uuid %}" class="btn btn-sm btn-outline-secondary">View</a>
                        {% if e.uuid in pinned_events %}
                            <form action="{% url 'events:unpin_event' %}" method="POST">
                                {% csrf_token %}
                                <input type="hidden" name="event_uuid" value="{{ e.uuid }}">
                                <button type="submit" class="btn btn-sm btn-outline-secondary">Unpin</button>
                            </form>
                        {% else %}
                            <button type="button" class="btn btn-sm btn-outline-secondary" data-bs-toggle="modal" data-bs-target="#pinEventModal{{ e.uuid }}">
                                Pin
                            </button>
                        {% endif %}
                            {% if e.uuid in registered_events %}
                                <button class="btn btn-sm btn-outline-secondary disabled">Registered</button>
                            {% else %}
                                <!-- Button trigger modal for registration -->
                                <button type="button" class="btn btn-sm btn-outline-secondary" data-bs-toggle="modal" data-bs-target="#registerEventModal{{ e.uuid }}">
                                    Register
                                </button>
                            {% endif %}
                        {% if e.committees.all|intersect:user_committees %}
                            <!-- Button trigger modal for registration -->
                            <form action="{% url 'events:registrations'%}" method="POST">
                                {% csrf_token %}
                                <div class="container text-right">
                                    <input type="hidden" name="event_uuid" value="{{ e.uuid }}">
                                    <button type="submit" class="btn btn-sm btn-outline-secondary text-primary">Registrations</button>
                                </div>
                            </form>
                        {% endif %}
                    </div>
                    
                </div>
            </div>
        </div>
    </div>
    <!-- Pin Event Modal -->
<!-- Pin Event Modal -->
<div class="modal fade" id="pinEventModal{{ e.uuid }}" tabindex="-1" aria-labelledby="pinEventModalLabel{{ e.uuid }}" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="pinEventModalLabel{{ e.uuid }}">Pin Event</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
                Are you sure you want to pin this event?
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                <form action="{% url 'events:pin_event' %}" method="POST">
                    {% csrf_token %}
                    <input type="hidden" name="event_uuid" value="{{ e.uuid }}">
                    <button type="submit" class="btn btn-primary">Pin Event</button>
                </form>
            </div>
        </div>
    </div>
</div>

    <!-- Register Event Modal -->
    <div class="modal fade" id="registerEventModal{{ e.uuid }}" tabindex="-1" aria-labelledby="registerEventModalLabel{{ e.uuid }}" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="registerEventModalLabel{{ e.uuid }}">Register Event</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    Are you sure you want to register for this event?
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                    <form action="{% url 'events:register_event' %}" method="POST">
                        {% csrf_token %}
                        <input type="hidden" name="event_uuid" value="{{ e.uuid }}">
                        <button type="submit" class="btn btn-primary">Register</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endfor %}

        </div>
    </div>
</div>
{% endblock main %}

frontend/templates/events/registrations.html
{% extends "base/base.html" %}

{% block main %}
<h2>Registrations for {{event.name}}</h2>
<hr>
<hr>

<div class="table-responsive small px-10 mx-10">
  <table class="table table-striped table-sm">
    <thead>
        <tr>
          <th scope="col">Sr. No</th>
          <th scope="col">Name</th>
          <th scope="col">Class</th>
          <th scope="col">Blood Group</th>
          <th scope="col">Contact Number</th>
          <th scope="col">Address</th>
          <th scope="col">Details</th>
        </tr>
      </thead>
      <tbody>
        {% for reg in registrations %}
          <tr>
            <td>{{ forloop.counter }}</td>
            <td>{{ reg.user.username }}</td>
            <td>{{ reg.user.profile.department_year }}</td>
            <td>{{ reg.user.profile.blood_group }}</td>
            <td>{{ reg.user.profile.contact_number }}</td>
            <td>{{ reg.user.profile.address }}</td>
            <td><a href="{% url 'profile' reg.user.username %}">View Profile</a></td>
          </tr>
        {% endfor %}
      </tbody>
  </table>
</div>
{% endblock main %}